/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.app.view.navigation.AdminNavigator");

dojo.require("dojo.i18n");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.requireLocalization("com.ibm.team.reports.web.app.internal", "ReportsMessages");

(function() { // module container

/**
 * Widget to display admin options.
 */
dojo.declare("com.ibm.team.reports.web.app.view.navigation.AdminNavigator",	[dijit._Widget, dijit._Templated], {
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "app/view/navigation/templates/AdminNavigator.html"),
		//templateCssPath: dojo.moduleUrl("com.ibm.team.reports.web", "app/view/navigation/templates/AdminNavigator.css"),

		constructor: function(args) {
			messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.app.internal", "ReportsMessages");
			this.controller = args.controller;
		},

		postCreate: function() {
			com.ibm.team.reports.web.app.view.navigation.AdminNavigator.superclass.postCreate.apply(this);
			this._addAdminLink();
		},

		/**
		 * Adds a link to the widget.
		 */
		_addAdminLink: function() {
            var linkDiv = document.createElement("div");
			linkDiv.className= "admin-div-unselected";

			var div = document.createElement("div");
			div.className = "admin-div";

			var anchor = document.createElement("a");
			anchor.href = "#action=com.ibm.team.reports.admin";
			anchor.title = messages.administerDataWarehouse;
			var text = document.createTextNode(messages.administerDataWarehouse);
			anchor.appendChild(text);
			div.appendChild(anchor);
			linkDiv.appendChild(div);
			
            this.adminListDiv.appendChild(linkDiv);
		}
	}
);

})();