/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.app.view.report.ReportsWelcome");

dojo.require("dojo.i18n");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.requireLocalization("com.ibm.team.reports.web.app.internal", "ReportsMessages");

(function() {

var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.declare("com.ibm.team.reports.web.app.view.report.ReportsWelcome",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "app/view/report/templates/ReportsWelcome.html"),
		
		constructor: function() {
			messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.app.internal", "ReportsMessages");
			this.welcomeToReports = messages.welcomeToReports;
			this.toGetStarted = dojo.string.substitute(messages.toGetStarted, ["<a class=\"welcomeLink\" href=#action=com.ibm.team.reports.newReport>", "</a>"]);
		},
		
		postCreate: function() {
			com.ibm.team.reports.web.app.view.report.ReportsWelcome.superclass.postCreate.apply(this);
		 	
		    this._canDeployQuery = false;
			var responseHandler = new ServiceResponseHandler(
				this,
				"_handleCanDeployQuery",
				"_remoteError");
			ReportsClient.getCanDeployQuery(responseHandler);
		},
		
		_handleCanDeployQuery: function(result) {
			if (result == "true") {
				return;
			}
			while (this._welcomeText.childNodes[0] != null) {
				this._welcomeText.removeChild(this._welcomeText.childNodes[0]);
			}
			this._welcomeText.appendChild(document.createTextNode(messages.gettingStarted));
		},
		
		_remoteError: function(error) {
		}
	}
);

})();