/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.client.internal.query.AttributeExpression");

//dojo.require("dojo.lang");

(function() {

dojo.declare("com.ibm.team.workitem.web.client.internal.query.AttributeExpression",
	null, {
		
	constructor: function(/* String */ attributeId, /* String */ operator, /* Array */ values) {
		
//		dojo.lang.assert(attributeId);
		
		var expr= new Object();
		expr.attributeId= attributeId;
		expr.operator= operator;
		expr.values= values ? values : new Array();
		expr.variables= new Array();
		this._expr= expr;
	},
	
	/* String */ serialize: function() {
		return dojo.toJson(this._expr);
	},
	
	// One of the operator IDs in AttributeOperation.java
	setOperator: function(/* String */ operator) {
		this._expr.operator= operator;
	},
	
	setValues: function(/* String[] */ values) {
//		dojo.lang.assert(values);
		for (var i= 0; i < values.length; i++) {
			this._expr.values.push(values[i]);
		}
	},
	
	setVariables: function(/* Variable[] */ variables) {
//		dojo.lang.assert(variables);
		for (var i = 0; i < variables.length; i++) {
			this._expr.variables.push(variables[i]._var);
		}
	}
	
});

})();