/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.ErrorViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;

var messages;

/*
 * A special viewlet that is displayed when a viewlet definition doesn't exist.
 * This can happen if the id changed and migration wasn't performed. When the server
 * cannot find a definition, it will return the definition for this viewlet.
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.ErrorViewlet",
	Viewlet, {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/ErrorViewlet.html"),
	
	constructor: function(args){
		messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
		this.heading = messages.errorViewletHeading;
	},
	
	/*
	 * Fill in the error message on creation.
	 */
	postCreate: function() {
		this._errorMsgSpan.innerHTML = dojo.string.substitute(messages.errorViewletMessage, ["&quot;" + this._helper.getDefinitionId() + "&quot;"]);
	}
});

})();
