/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		
	templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/TeamInvitationDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
	
	constructor: function (args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.selectedMembers = new Array();
		this.singleUser = {};
	},

	postCreate: function () {
		this.populateObj();
		this.connect(this.selectAllButton, "onclick", "handleSelectAll"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.deselectAllButton, "onclick", "handleDeselectAll"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	repopulate: function (data) {
		this.newMembers = data.newMembers;
		this.newTeamMembers.options.length = 0;
		this.populateObj();
	},
	
	populateObj: function () {
		dojo.forEach(this.newMembers, function(member) {
			var option = new Option(member.name, member.itemId);
			option.selected = true;
			if (dojo.isIE) {
				this.newTeamMembers.options[this.newTeamMembers.options.length] = option;
			}
			else {
				this.newTeamMembers.appendChild(option);
			}
		}, this);
	},
	
	handleSelectAll: function (e) {
		dojo.forEach(this.newTeamMembers.options, function(item) {
			item.selected = true;
		});
		this.okButton.focus();
	},
	
	handleDeselectAll: function (e) {
		dojo.forEach(this.newTeamMembers.options, function(item) {
			item.selected = false;
		});
	},
	
	getChosenMembers: function () {
		var chosenMembers = new Array();
		dojo.forEach(this.newTeamMembers.options, function(option) {
    		if (option.selected) { 
    			chosenMembers.push(option.value);
			}
		});
		if (chosenMembers.length == 1) {
			this.singleUser = this.newMembers[this.newTeamMembers.selectedIndex];
		}
		return chosenMembers;
	}
});

})();