/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore", null, { //$NON-NLS-1$

	constructor: function(initialItems) {
		this._store= {};
		if (dojo.isArray(initialItems)) {
			this.addItems(initialItems);
		}
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	addItems: function(referencedItems) {
		for (var i= 0; i < referencedItems.length; i++) {
			var item= referencedItems[i];
			var key= this._getKeyByItem(item);
			this._store[key]= item; 
		}
	},
	
	getItem: function(type, id) {
		return this._store[this._getKeyByTypeAndId(type, id)];
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_getKeyByItem: function(item) {
		return this._getKeyByTypeAndId(item.itemType, item.itemId);
	},

	_getKeyByTypeAndId: function(type, id) {
		return type + ":" + id; //$NON-NLS-1$
	},
	
	__sentinel: null // terminates this class definition
});

com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore.ITEM_TYPES= {
	CONTRIBUTOR: "item:Contributor@com.ibm.team.repository", //$NON-NLS-1$
	TEAMAREA: "item:TeamArea@com.ibm.team.process", //$NON-NLS-1$
	ITERATION: "item:Iteration@com.ibm.team.process", //$NON-NLS-1$
	CATEGORY: "item:Category@com.ibm.team.workitem", //$NON-NLS-1$
	DEVLINE: "item:DevelopmentLine@com.ibm.team.process", //$NON-NLS-1$
	PRIORITY: "object:priority@com.ibm.team.workitem", //$NON-NLS-1$
	SEVERITY: "object:severity@com.ibm.team.workitem", //$NON-NLS-1$
	WITYPE: "object:type@com.ibm.team.workitem", //$NON-NLS-1$
	WISTATE: "object:state@com.ibm.team.workitem", //$NON-NLS-1$
	WIRESOLUTION: "object:resolution@com.ibm.team.workitem" //$NON-NLS-1$
};

})();
