/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.AttachmentsPart");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuDropDownActionWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemAttachments");


/*
 * This is a wrapper widget that shows the Approvals Section
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.AttachmentsPart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="AttachmentsPart SectionPart">' +
						'<span dojoAttachPoint="_sectionMenuSPAN"></span>' +
						'<div class="contentNode" dojoAttachPoint="_contentNode"></div>' +
						'</div>',

		postCreate: function() {	
			this._childWidgets = [];
//			this._contentNode.innerHTML = "Loading..."; /* innerHTML OK */
			this._isInitialized = false;

		},
		destroyWidget: function() {
			this.resetWidget();
			this.destroy();
		},
		resetWidget: function() {
			this.parentController.pageController.removeAllMouseListeners(this);
			for(var i = 0; i< this._childWidgets.length; i++) {
				this._childWidgets[i].destroyWidget();
			}
			this._childWidgets = [];
		},
		/*
		 * Load the tab when it is shown
		 */
		showWidget: function() {
			if(this._isInitialized) {
				if(this.sectionWidget) {
					this.sectionWidget.showWidget();
				}
				return;
			} 
			this._isInitialized = true;
			this.refresh();
//			setTimeout(dojo.hitch(this, this.refresh), 100);
		},
		
		/*
		 * Setup the page and read the states and types 
		 */
		refresh: function() {
			this.resetWidget();
			
			dojox.data.dom.removeChildren(this._contentNode);
			
			var createArgs= {
				parentController: this.parentController, // WorkItemEditor
				editorUtil: this.parentController.editorUtil,
				retainedState: this.retainedState
			};
			
			
			this.sectionWidget = /* createWidget */ new com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemAttachments( createArgs);
			this.sectionWidget.reset();
			this.sectionWidget.bindWorkItem(this.parentController._workItem);

			this._childWidgets.push(this.sectionWidget);
			this._contentNode.appendChild(this.sectionWidget.domNode);
			
		},	
		isUploadInProgress: function() {
			if(!this.sectionWidget || !this.sectionWidget.isUploadInProgress) return false;
			return this.sectionWidget.isUploadInProgress();
		},
		cancelUploadInProgress: function() {
			if(!this.sectionWidget || !this.sectionWidget.cancelUploadInProgress) return false;
			return this.sectionWidget.cancelUploadInProgress();
		},
		//
		// Part API Metnods
		//
		

		setReadOnly: function(isReadOnly) {
//			this.inputWidget.setReadOnly(isReadOnly);
		},
		getFormElementValues: function(formElements) {

		},
		setFormElementValues: function(retainedState){

			},
		/*
		 * Add commands to the updateLinks commands 
		 *
		 */ 
		 getSaveCommands: function (allCommands) {
		 	if(this.sectionWidget) {
				return this.sectionWidget.getSaveCommands(allCommands);
			}
		 	return allCommands;
		 },
	     getValue: function() {

		 }
	}
);

})();
