/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() {

var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNonNegative		= net.jazz.ajax.toolbox.lang.checkNonNegative;

dojo.require("com.ibm.team.workitem.web.client.internal.ImageClient");

dojo.require("net.jazz.ajax.core.internal.loader");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionLayout");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SeparatorWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TimestampWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TeamAreaWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.ContributorWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.HTMLWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.DiscussionWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SimpleInputWidget"); 
// The "Parts" can be dynamicallly loaded, but they must be required somewhere to enable debugging
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.ApprovalsPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.AttachmentsPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.LinksPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.QuickInformationPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.DurationAttributePart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.EstimateAndCorrectionAttributePart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValidatedAttributePart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.BooleanAttributePart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.HistoryPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.RadioGroupPart");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");

var ImageClient	= com.ibm.team.workitem.web.client.internal.ImageClient;
var Loader = net.jazz.ajax.core.internal.loader;

com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil = {
		messages: dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages"),
       /*
        * Keep track of missing widgets so they are only attempted to be loaded once
        */
		missingWidgetMap:{ },

       /*
        * Some widgets are preloaded
        */
		loadedWidgetMap: {
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_ApprovalsPart: false,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_AttachmentsPart: false,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_LinksPart: false,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_QuickInformationPart: com.ibm.team.workitem.web.ui.internal.view.editor.parts.QuickInformationPart,
			
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_DiscussionPart: com.ibm.team.workitem.web.ui.internal.view.layout.DiscussionWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_SeparatorPart: com.ibm.team.workitem.web.ui.internal.view.layout.SeparatorWidget,
			
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_ContributorAttributePart: com.ibm.team.workitem.web.ui.internal.view.layout.ContributorWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_EnumerationAttributePart:  com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_HTMLAttributePart: com.ibm.team.workitem.web.ui.internal.view.layout.HTMLWidget,
//			com_ibm_team_workitem_web_ui_internal_view_editor_parts_StringAttributePart: com.ibm.team.workitem.web.ui.internal.view.layout.HTMLWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_TagsAttributePart: com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_TargetAttributePart:  com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_TeamAreaAttributePart: com.ibm.team.workitem.web.ui.internal.view.layout.TeamAreaWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_TimestampAttributePart: com.ibm.team.workitem.web.ui.internal.view.layout.TimestampWidget,			
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_CategoryAttributePart: com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_SimpleInputPart: com.ibm.team.workitem.web.ui.internal.view.layout.SimpleInputWidget,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_DurationAttributePart: com.ibm.team.workitem.web.ui.internal.view.editor.parts.DurationAttributePart,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_EstimateAndCorrectionAttributePart: com.ibm.team.workitem.web.ui.internal.view.editor.parts.EstimateAndCorrectionAttributePart,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_ValidatedAttributePart: com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValidatedAttributePart,
			com_ibm_team_workitem_web_ui_internal_view_editor_parts_BooleanAttributePart: com.ibm.team.workitem.web.ui.internal.view.editor.parts.BooleanAttributePart
//			com_ibm_team_workitem_web_ui_internal_view_editor_parts_HistoryPart: false,
//			com_ibm_team_workitem_web_ui_internal_view_editor_parts_SubscribersPart: false
			
			},
			genericWidgetMap: {
				com_ibm_team_workitem_web_ui_internal_view_editor_parts_IntegerAttributePart: {
					widgetName: "com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValidatedAttributePart",
					validationRegex: "\\d*,*",
					validationMessage: "validationAsInteger",
					isNumber: true
				},
				com_ibm_team_workitem_web_ui_internal_view_editor_parts_LongAttributePart: {
					widgetName: "com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValidatedAttributePart",
					validationRegex: "\\d*",
					validationMessage: "validationAsLong",
					isNumber: true
				}
				,com_ibm_team_workitem_web_ui_internal_view_editor_parts_StringAttributePart: {
					widgetName: "com_ibm_team_workitem_web_ui_internal_view_editor_parts_HTMLAttributePart",
					modifiers: {
						isString: true,
						isSpanningColumns: true
					}		}
				,com_ibm_team_workitem_web_ui_internal_view_editor_parts_HTMLAttributePart: {
					widgetName: "com_ibm_team_workitem_web_ui_internal_view_editor_parts_HTMLAttributePart",
					modifiers: {
						isString: false,
						isSpanningColumns: true
					}		}
			},
		/*
		 * Layout a section
		 */
		layoutSection: function(renderObject, section, sectionMap, columnLayout, parentController, widgetArray) {
			var slot = section.slot;
			if(!slot) { section.slot = "defaultSection"};
			var mapping = sectionMap[section.slot];
			if (!mapping) {
				mapping = sectionMap["defaultSection"];
			};
			if(mapping && renderObject[ mapping.renderFunctionName ]) {
				
				var div = document.createElement('div');
				if(mapping.className) {
					dojo.addClass(div, mapping.className);					
				}
				if(mapping.highlightBackground) {
					dojo.addClass(div, "SectionBackground");					
				}
				var title= this.getPropertyMap(section).title
				var sectionLayout = /* createWidget */ new com.ibm.team.workitem.web.ui.internal.view.layout.SectionLayout( 
					{heading: title, column: mapping.column, parentController: parentController} , div);
				widgetArray["section-" + slot] = sectionLayout;
				div = document.createElement('div');
				sectionLayout.setContent(div);
				columnLayout.addSection(sectionLayout, mapping.column);
			
				renderObject[ mapping.renderFunctionName ](div,section, sectionLayout);
			}
		},
		getValueMap: function(valueArray) {
			var values = {};
			dojo.forEach(valueArray, function(value) {
				if(value && value.attributeName && value.uiItems) {
					values[value.attributeName] = value.uiItems;
				}
			})
			return values;
		},
		getPropertyMap: function(propertyObject, originalObject) {
			var properties;
			if(originalObject) {
				properties = originalObject;
			} else {
				properties = {}
			}
			dojo.forEach(propertyObject.properties, function(property) {
//				if(properties[property.key]) {
//					console.debug("**WARNING**: property " + property.key + " was replaced in LayoutUtil.getPropertyMap.");
//				}
				properties[property.key] = property.value;
			})
			return properties;
		},
		getPresentationWidget:function(presentation) {
			var key = presentation.widget.replace(/\./g, "_");
			
			var result= {
				widgetName: presentation.widget,
				isMissingWidget: false
			};
			
			if(this.genericWidgetMap[key]) {
				result.originalWidgetName = presentation.widget;
				result.widgetName = this.genericWidgetMap[key].widgetName;
				if(this.genericWidgetMap[key].validationRegex) result.validationRegex=  this.genericWidgetMap[key].validationRegex;
				if(this.genericWidgetMap[key].validationMessage) result.validationMessage= this.messages[this.genericWidgetMap[key].validationMessage];
				if(this.genericWidgetMap[key].isNumber)	result.isNumber= this.genericWidgetMap[key].isNumber ? true : false;
				if(this.genericWidgetMap[key].modifiers) result.modifiers= this.genericWidgetMap[key].modifiers;
				key = this.genericWidgetMap[key].widgetName.replace(/\./g, "_");
			}
			
			if(!this.loadedWidgetMap[key]) {
				/*
				 * If it is not loaded and not missing, attempt to load it
				 */
				var loadedWidget;
				if(!this.missingWidgetMap[key]) {
					try{
						Loader.load_sync(presentation.widget);
						loadedWidget = eval(presentation.widget);
						} catch(e){
							console.debug("WorkItemEditor could not load: " + presentation.widget);
						}					
				}

				if(loadedWidget) {
					result.widget = loadedWidget;
					this.loadedWidgetMap[key] = loadedWidget;
				} else {
					this.missingWidgetMap[key] = presentation.widget;
					result.widget = com.ibm.team.workitem.web.ui.internal.view.layout.SeparatorWidget;
					result.isMissingWidget= true;
				}
								
			} else {
				result.widget = this.loadedWidgetMap[key];
			}

// This doesn't work because the widget is a prototype and not an object			
//			if(result.widget.displaySpec) {
//				this.mergeObjects(displaySpec, result.widget.displaySpec);	
//			}
			
			return result;
		},
		getImageUrl: function(imageName) {
			return ImageClient.getImageUrl(imageName);
		},
		/*
		 * Merge two objects. The second object has priority
		 */
		mergeObjects: function(object1, object2) {
			if(!object1 && !object2) return {};
			if(!object1) return object2;
			if(!object2) return object1;
			var result = object1;
			for(var key in object2) {
				result[key] = object2[key];
			}
			return result;
		}
};

})();
