/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.TeamAreaWidget");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");
(function() {

var WidgetUtil  = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var EditorUtil 	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.layout.TeamAreaWidget",
	[dijit._Widget, dijit._Templated],
	{
		templateString: '<div class="TeamAreaWidget NarrowWidget">' +
						'<img dojoAttachPoint="_spacer" class="PreFieldImage" />' +
						'<span dojoAttachPoint="_labelSPAN" class="LayoutValue"></span>' +
						'</div>',
 		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");
		},
		postCreate: function() {
			WidgetUtil.setSpacerImage(this._spacer);
			var value =  WidgetUtil.getFirstValue(this.values);

			this.setValue(value);
		},
		shorten: function(text) {
			if(text.length < 30) return text;
			var result = "", i=0;
			while(i<text.length) { 
				result = result + text.substring(i,Math.min(i+30, text.length)) + " ";
				i += 30;
			}
			if(i<text.length) {
				result = result + text.substring(i,text.length-1);
			}
			result = dojo.trim(result);
			return result;
		},
		setValue: function(value) {
			if(!value || value.length == 0) {
				value = this.messages.labelDefaultNullContributor;
				dojo.addClass(this._labelSPAN, "GreyLabel")
			} else {
				dojo.removeClass(this._labelSPAN, "GreyLabel")
			}
			
			var split = value.split(" ");
			value = "";
			for (var i=0;i<split.length;i++) {
				var next = this.shorten(split[i]);
				value = value +  next + " ";
			}
			value = dojo.trim(value);

			dojox.data.dom.replaceChildren(this._labelSPAN, document.createTextNode(value));			
		}
	}
);

})();
