/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage"); //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.Tab"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var PlanningUtil		= com.ibm.team.apt.web.client.util;
var ImageClient			= com.ibm.team.apt.web.client.internal.ImageClient;
var PlanningClient		= com.ibm.team.apt.web.client.internal.PlanningClient;
var ResponseHandler		= com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler;
var Tab					= com.ibm.team.apt.web.ui.internal.view.plan.Tab;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.Tab, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_pageId: null,
	_planId: null,
	_pageContent: null,
	
	_attachedPageContent: null,

	constructor: function() {
		this._notYetShown= true;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------	


	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/templates/TabAttachedPage.html"), //$NON-NLS-1$ //$NON-NLS-2$

	// ---- Tab.js implementation ------------------------------------------------------------------------------------------

	widgetAboutToShow: function() {
		if (this._notYetShown) {
			if (this._rootGroup == null) {
				var serviceCallController= this._getServiceCallController(); 
				
				var _self= this;
				var serviceCallback= {
					_success: function(result) {
						_self._displayAttachedPageContent(result.pageContent);
					},
					_error: function(error) {
						serviceCallController.remoteError(error);
					}
				}
				
				var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
				responseHandler.setLabel(MSGS.MONITOR_LOAD_ATTACHEDPAGE, serviceCallController);		
				PlanningClient.fetchAttachedPage(responseHandler, this._planId, this._pageId);

			} else {
				this._displayAttachedPageContent(this._pageContent);
			}

			this._notYetShown= false;
		}
	},
	
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	_displayAttachedPageContent: function(pageContent) {
		// TODO we should be more carefull about what we insert here!
		this._pageContent= pageContent;
		this._attachedPageContent.innerHTML= pageContent;
	},

	__sentinel: null // terminates this class definition
});

/**
 * This helper method creates the arguments object for the widget's constructor.
 * @return {Object} a widget private object to be passed in as a constructor argument
 */
com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage.constructorArgs= function(iterationPlanPage, attachedPageStub, attachedPageData, serviceCallController) {
	var result= {
		_pageId: attachedPageStub.itemId,
		_planId: iterationPlanPage.getPlanId()
	};
	
	if (attachedPageData != null) {
		result._pageContent= attachedPageData.pageContent;
	}


	var tabId= attachedPageStub.itemId;
	var tabLabel= attachedPageStub.label;
	if (tabId != "overview") { //$NON-NLS-1$
		if (!tabId.match(/[\w\$\.\+\!\*\'\(\)-,]*/)) {
			tabId= encodeURI(tabId);
		}
		tabId= "wikiPage_" + tabId; //$NON-NLS-1$
	} else {
		tabLabel= MSGS.ATTACHEDPAGE_TAB_OVERVIEW;
	}
	return dojo.mixin(result, Tab.constructorArgs(iterationPlanPage, tabId, tabLabel, serviceCallController));
};

})();
